
local StoneGateV6 = ...

-- Apply building asset processor
StoneGateV6:registerAssetProcessor("models/basic/basicSmallGate.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Register LargeGate prefab nodes
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart", "STONE_GATE_V6_SGATE_ROOT_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart/Pillar1_SGate_Part", "STONE_GATE_V6_SGATE_PILLAR1_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart/Pillar2_SGate_Part", "STONE_GATE_V6_SGATE_PILLAR2_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling1Part", "STONE_GATE_V6_SGATE_TILING1_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling2Part", "STONE_GATE_V6_SGATE_TILING2_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_Tiling3Part", "STONE_GATE_V6_SGATE_TILING3_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_ext_Tiling1Part", "STONE_GATE_V6_SGATE_EXT_TILING1_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_RootBPart", "STONE_GATE_V6_SGATE_ROOTB_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BPart", "STONE_GATE_V6_SGATE_TILING1B_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BEPart", "STONE_GATE_V6_SGATE_TILING1BE_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling2BPart", "STONE_GATE_V6_SGATE_TILING2B_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling3BPart", "STONE_GATE_V6_SGATE_TILING3B_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BPPart", "STONE_GATE_V6_SGATE_TILING1BP_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling1BEPPart", "STONE_GATE_V6_SGATE_TILING1BEP_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling2BPPart", "STONE_GATE_V6_SGATE_TILING2BP_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_Tiling3BPPart", "STONE_GATE_V6_SGATE_TILING3BP_PREFAB")
StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_TopPart", "STONE_GATE_V6_SGATE_TOP_PREFAB")
--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart2(_nodePrefix)
	StoneGateV6:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		Mover = { DataType = "BUILDING_PART_MOVER" },
		ConstructorData = {
                    DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
                    CoreObjectPrefab = _nodePrefix .. "_PREFAB"
                },
	        Cost = {
		    UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		    },
		    RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		    }
	        },
	        EstateSplendor = {
		    { Estate = "KINGDOM", Quantity = 0.1 }
	    }
	})
end

local defaultNodePrefixList2 = {
        "STONE_GATE_V6_SGATE_PILLAR1",
        "STONE_GATE_V6_SGATE_PILLAR2",
	"STONE_GATE_V6_SGATE_TOP",
	"STONE_GATE_V6_SGATE_TILING1",
	"STONE_GATE_V6_SGATE_TILING2",
	"STONE_GATE_V6_SGATE_TILING3",
	"STONE_GATE_V6_SGATE_EXT_TILING1",
	"STONE_GATE_V6_SGATE_TILING1B",
	"STONE_GATE_V6_SGATE_TILING1BE",
	"STONE_GATE_V6_SGATE_TILING2B",
	"STONE_GATE_V6_SGATE_TILING3B",
	"STONE_GATE_V6_SGATE_TILING1BP",
	"STONE_GATE_V6_SGATE_TILING1BEP",
	"STONE_GATE_V6_SGATE_TILING2BP",
	"STONE_GATE_V6_SGATE_TILING3BP"
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList2) do
	registerDefaultBuildingPart2(nodePrefix)
end

-- Register the stone gate set small gate root part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_ROOT_PART",
	Name = "STONE_GATE_V6_SGATE_ROOT_NAME",
	Description = "STONE_GATE_V6_SGATE_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOT_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_ROOTB_PART", -- "STONE_GATE_V6_SGATE_ROOTB_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING1B_PART",
			"STONE_GATE_V6_SGATE_TILING3_PART",
			"STONE_GATE_V6_SGATE_TILING2_PART",
			"STONE_GATE_V6_SGATE_TILING3_PART",
			"STONE_GATE_V6_SGATE_TILING2_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V6_SGATE_TILING1_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})


-- Register the stone gate set small gate root part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_ROOTB_PART",
--	Name = "STONE_GATE_V6_SGATE_ROOTB_NAME",
--	Description = "STONE_GATE_V6_SGATE_ROOTB_DESC",
--	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_BRIDGE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOTB_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_TOP_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING3B_PART",
			"STONE_GATE_V6_SGATE_TILING2B_PART"
                },
--		BasementFillerList = {
--			"STONE_GATE_V6_SGATE_TILING1B_PART"
  -- 	        },
		MinimumScale = 0,
		BasementScale = 0,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})

-- Register the stone gate set small gate extension root part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_EXT_ROOT_PART",
	Name = "STONE_GATE_V6_SGATE_EXT_ROOT_NAME",
	Description = "STONE_GATE_V6_SGATE_EXT_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOT_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_ROOTB_PART", -- "STONE_GATE_V6_SGATE_ROOTB_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING1BE_PART",
			"STONE_GATE_V6_SGATE_TILING3B_PART",
			"STONE_GATE_V6_SGATE_TILING2B_PART",
			"STONE_GATE_V6_SGATE_TILING3B_PART",
			"STONE_GATE_V6_SGATE_TILING2B_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V6_SGATE_EXT_TILING1_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})

-- Register the stone gate set small gate root with wooden floor part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_ROOTP_PART",
	Name = "STONE_GATE_V6_SGATE_ROOTP_NAME",
	Description = "STONE_GATE_V6_SGATE_ROOTP_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOT_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_ROOTBP_PART", -- "STONE_GATE_V6_SGATE_ROOTB_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING1BP_PART",
			"STONE_GATE_V6_SGATE_TILING3_PART",
			"STONE_GATE_V6_SGATE_TILING2_PART",
			"STONE_GATE_V6_SGATE_TILING3_PART",
			"STONE_GATE_V6_SGATE_TILING2_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V6_SGATE_TILING1_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})


-- Register the stone gate set small gate root with wooden floor part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_ROOTBP_PART",
--	Name = "STONE_GATE_V6_SGATE_ROOTBP_NAME",
--	Description = "STONE_GATE_V6_SGATE_ROOTBP_DESC",
--	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_BRIDGE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOTB_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_TOP_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING3BP_PART",
			"STONE_GATE_V6_SGATE_TILING2BP_PART"
                },
--		BasementFillerList = {
--			"STONE_GATE_V6_SGATE_TILING1BP_PART"
  -- 	        },
		MinimumScale = 0,
		BasementScale = 0,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})

-- Register the stone gate set small gate extension root with wooden floor part
StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_EXT_ROOTP_PART",
	Name = "STONE_GATE_V6_SGATE_EXT_ROOTP_NAME",
	Description = "STONE_GATE_V6_SGATE_EXT_ROOTP_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_ROOT_PREFAB",
		EndPart = "STONE_GATE_V6_SGATE_ROOTBP_PART", -- "STONE_GATE_V6_SGATE_ROOTB_PART",
		FillerList = {
			"STONE_GATE_V6_SGATE_TILING1BEP_PART",
			"STONE_GATE_V6_SGATE_TILING3BP_PART",
			"STONE_GATE_V6_SGATE_TILING2BP_PART",
			"STONE_GATE_V6_SGATE_TILING3BP_PART",
			"STONE_GATE_V6_SGATE_TILING2BP_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V6_SGATE_EXT_TILING1_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	},
	EstateSplendor = {
		{ Estate = "KINGDOM", Quantity = 1 }
	}
})

--------------------------------------------------------------------------
-- Register flag assigner component on the collider's type to 'PLATFORM'

--StoneGateV6:configurePrefabFlagList("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_3_SGate_TopPart", { "PLATFORM" })
 
-- Register grass clearing components

StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = { 4, 8 }
})

-- Override building part components properties (generated by the building asset processor) to add building zones
StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = false,
	BuildingZone = { 0, 0 }
})
--[[
StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_2_SGate_RootBPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 8 }
})
]]
StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart/Pillar1_SGate_Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 4 }
})

StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_0_SGate_RootPart/Pillar2_SGate_Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 2, 4 }
})

StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_1_SGate_ext_Tiling1Part", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 8 }
})

function registerRampartPart(_nameFbx, _nameAsset, _attachType)
    StoneGateV6:registerAssetId("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_4_SGate_" .. _nameFbx .. "Part", "STONE_GATE_V6_SGATE_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration rampart part
    StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V6_SGATE_" .. _nameAsset .. "_PART",
	Name = "STONE_GATE_V6_SGATE_" .. _nameAsset .. "_NAME",
	Description = "STONE_GATE_V6_SGATE_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V6_SGATE_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 2 }
		}
	}
    })

    StoneGateV6:registerPrefabComponent("models/basic/basicSmallGate.fbx/Prefab/smallGate/step_4_SGate_" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = _attachType, 
	BuildingZone = { 0, 0 }
    })
end

registerRampartPart( "RampartA", "RAMPART_A", "MAJOR" )
registerRampartPart( "RampartClosingL", "RAMPART_CLOSING_L", "MINOR" )
registerRampartPart( "RampartClosingR", "RAMPART_CLOSING_R", "MINOR" )
registerRampartPart( "HalfRoof", "HALF_ROOF", "MAJOR" )
registerRampartPart( "HalfRoofP", "HALF_ROOFP", "MAJOR" )

